%{
Ek = [];
Emk = [];
for i = 1:100
	[Ek(i), Emk(i)] = test_mahalanobis(@ackley, @lhsu, 10);
	drawnow()
	i
end
mean(Ek)
std(Ek)
mean(Emk)
std(Emk)
%}

%{
runs = 10;
maxgen = 120;
Ek = zeros(runs, maxgen);
Emk = zeros(runs, maxgen);
for i = 1:runs
	param.m = 100;
	param.nb_select = @lhsu_reference_nb_select;
	param.doplot = false;
	param.optimizer = @cmaes;
	param.bch = @cutoff_bc;
	[xopt, fopt, stat] = ro_cmaes_kriging_compare(@rotated_sphere, 10, -10 * ones(10,1), 10 * ones(10,1), .5 * ones(10,1), maxgen, -1, param);
	Ek(i,:) = stat.approximation_error_k;
	Emk(i,:) = stat.approximation_error_mk;
	i
end
clf
plot(mean(Ek), 'b')
hold on
plot(mean(Emk), '-.r')
legend('Normal Kriging', 'Mahalanobis Kriging');
ylabel('mean approximation error of generation');
xlabel('generation');
%}

%{
fitnessfct = @rotated_sphere;
N = 10;
lb = -10 * ones(N,1);
ub = 10 * ones(N,1);
delta = .5 * ones(N,1);
stopeval = 5000;
param.doplot = false;
param.bch = @cutoff_bc;
param.m = 100;
param.nb_select = @lhsu_reference_nb_select_single_candidate;
param.kriging_method = 'normal';
[xopt, fopt, stat] = ro_cmaes_kriging_additional_stats(fitnessfct, N, lb, ub, delta, stopeval, -1, param);
%}

subplot(2,2,1)
plot(stat.model_construction_time, 'linewidth', 2)
xlabel('Candidate solution evaluations', 'FontSize', 20)
ylabel('Metamodel construction time (s)', 'FontSize', 20)
set(gca,'FontSize', 20)
subplot(2,2,2)
plot(stat.archive_selection_time, 'linewidth', 2)
xlabel('Candidate solution evaluations', 'FontSize', 20)
ylabel('Archive selection time (s)', 'FontSize', 20)
set(gca,'FontSize', 20)
subplot(2,1,2)
plot(stat.num_extra_samples, 'linewidth', 2)
xlabel('Candidate solution evaluations', 'FontSize', 20)
ylabel('Additional samples', 'FontSize', 20)
set(gca,'FontSize', 20)
